# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'FileSystemBackupPolicyStatus',
    'FileSystemProtectionReplicationOverwriteProtection',
    'MountTargetIpAddressType',
]


@pulumi.type_token("aws-native:efs:FileSystemBackupPolicyStatus")
class FileSystemBackupPolicyStatus(builtins.str, Enum):
    """
    Set the backup policy status for the file system.
      +  *ENABLED* - Turns automatic backups on for the file system. 
      +  *DISABLED* - Turns automatic backups off for the file system.
    """
    DISABLED = "DISABLED"
    ENABLED = "ENABLED"


@pulumi.type_token("aws-native:efs:FileSystemProtectionReplicationOverwriteProtection")
class FileSystemProtectionReplicationOverwriteProtection(builtins.str, Enum):
    """
    The status of the file system's replication overwrite protection.
      +  ``ENABLED`` – The file system cannot be used as the destination file system in a replication configuration. The file system is writeable. Replication overwrite protection is ``ENABLED`` by default. 
      +  ``DISABLED`` – The file system can be used as the destination file system in a replication configuration. The file system is read-only and can only be modified by EFS replication.
      +  ``REPLICATING`` – The file system is being used as the destination file system in a replication configuration. The file system is read-only and is modified only by EFS replication.
      
     If the replication configuration is deleted, the file system's replication overwrite protection is re-enabled, the file system becomes writeable.
    """
    DISABLED = "DISABLED"
    ENABLED = "ENABLED"


@pulumi.type_token("aws-native:efs:MountTargetIpAddressType")
class MountTargetIpAddressType(builtins.str, Enum):
    """
    The IP address type for the mount target. The possible values are `IPV4_ONLY` (only IPv4 addresses), `IPV6_ONLY` (only IPv6 addresses), and `DUAL_STACK` (dual-stack, both IPv4 and IPv6 addresses). If you don’t specify an `IpAddressType` , then `IPV4_ONLY` is used.

    > The `IPAddressType` must match the IP type of the subnet. Additionally, the `IPAddressType` parameter overrides the value set as the default IP address for the subnet in the VPC. For example, if the `IPAddressType` is `IPV4_ONLY` and `AssignIpv6AddressOnCreation` is `true` , then IPv4 is used for the mount target. For more information, see [Modify the IP addressing attributes of your subnet](https://docs.aws.amazon.com/vpc/latest/userguide/subnet-public-ip.html) .
    """
    IPV4_ONLY = "IPV4_ONLY"
    IPV6_ONLY = "IPV6_ONLY"
    DUAL_STACK = "DUAL_STACK"
