# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'EnvironmentCheckResult',
    'EnvironmentCheckType',
    'EnvironmentHostInfoForCreateInstanceType',
    'EnvironmentState',
    'EnvironmentVcfVersion',
]


@pulumi.type_token("aws-native:evs:EnvironmentCheckResult")
class EnvironmentCheckResult(builtins.str, Enum):
    PASSED = "PASSED"
    FAILED = "FAILED"
    UNKNOWN = "UNKNOWN"


@pulumi.type_token("aws-native:evs:EnvironmentCheckType")
class EnvironmentCheckType(builtins.str, Enum):
    """
    The check type. Amazon EVS performs the following checks.

    - `KEY_REUSE` : checks that the VCF license key is not used by another Amazon EVS environment. This check fails if a used license is added to the environment.
    - `KEY_COVERAGE` : checks that your VCF license key allocates sufficient vCPU cores for all deployed hosts. The check fails when any assigned hosts in the EVS environment are not covered by license keys, or when any unassigned hosts cannot be covered by available vCPU cores in keys.
    - `REACHABILITY` : checks that the Amazon EVS control plane has a persistent connection to SDDC Manager. If Amazon EVS cannot reach the environment, this check fails.
    - `HOST_COUNT` : Checks that your environment has a minimum of 4 hosts, which is a requirement for VCF 5.2.1.

    If this check fails, you will need to add hosts so that your environment meets this minimum requirement. Amazon EVS only supports environments with 4-16 hosts.
    """
    KEY_REUSE = "KEY_REUSE"
    KEY_COVERAGE = "KEY_COVERAGE"
    REACHABILITY = "REACHABILITY"
    VCF_VERSION = "VCF_VERSION"
    HOST_COUNT = "HOST_COUNT"


@pulumi.type_token("aws-native:evs:EnvironmentHostInfoForCreateInstanceType")
class EnvironmentHostInfoForCreateInstanceType(builtins.str, Enum):
    """
    The EC2 instance type that represents the host.
    """
    I4I_METAL = "i4i.metal"


@pulumi.type_token("aws-native:evs:EnvironmentState")
class EnvironmentState(builtins.str, Enum):
    CREATING = "CREATING"
    CREATED = "CREATED"
    DELETING = "DELETING"
    DELETED = "DELETED"
    CREATE_FAILED = "CREATE_FAILED"


@pulumi.type_token("aws-native:evs:EnvironmentVcfVersion")
class EnvironmentVcfVersion(builtins.str, Enum):
    """
    The VCF version of the environment.
    """
    VCF521 = "VCF-5.2.1"
