# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ClusterEncryptionInTransitClientBroker',
    'ClusterEnhancedMonitoring',
    'ClusterStorageMode',
    'ReplicatorReplicationInfoTargetCompressionType',
    'ReplicatorReplicationStartingPositionType',
    'ReplicatorReplicationTopicNameConfigurationType',
    'VpcConnectionAuthentication',
]


@pulumi.type_token("aws-native:msk:ClusterEncryptionInTransitClientBroker")
class ClusterEncryptionInTransitClientBroker(builtins.str, Enum):
    """
    Indicates the encryption setting for data in transit between clients and brokers. You must set it to one of the following values.

    - `TLS` : Indicates that client-broker communication is enabled with TLS only.
    - `TLS_PLAINTEXT` : Indicates that client-broker communication is enabled for both TLS-encrypted, as well as plaintext data.
    - `PLAINTEXT` : Indicates that client-broker communication is enabled in plaintext only.

    The default value is `TLS` .
    """
    TLS = "TLS"
    TLS_PLAINTEXT = "TLS_PLAINTEXT"
    PLAINTEXT = "PLAINTEXT"


@pulumi.type_token("aws-native:msk:ClusterEnhancedMonitoring")
class ClusterEnhancedMonitoring(builtins.str, Enum):
    """
    Specifies the level of monitoring for the MSK cluster.
    """
    DEFAULT = "DEFAULT"
    PER_BROKER = "PER_BROKER"
    PER_TOPIC_PER_BROKER = "PER_TOPIC_PER_BROKER"
    PER_TOPIC_PER_PARTITION = "PER_TOPIC_PER_PARTITION"


@pulumi.type_token("aws-native:msk:ClusterStorageMode")
class ClusterStorageMode(builtins.str, Enum):
    """
    This controls storage mode for supported storage tiers.
    """
    LOCAL = "LOCAL"
    TIERED = "TIERED"


@pulumi.type_token("aws-native:msk:ReplicatorReplicationInfoTargetCompressionType")
class ReplicatorReplicationInfoTargetCompressionType(builtins.str, Enum):
    """
    The type of compression to use writing records to target Kafka cluster.
    """
    NONE = "NONE"
    GZIP = "GZIP"
    SNAPPY = "SNAPPY"
    LZ4 = "LZ4"
    ZSTD = "ZSTD"


@pulumi.type_token("aws-native:msk:ReplicatorReplicationStartingPositionType")
class ReplicatorReplicationStartingPositionType(builtins.str, Enum):
    """
    The type of replication starting position.
    """
    LATEST = "LATEST"
    EARLIEST = "EARLIEST"


@pulumi.type_token("aws-native:msk:ReplicatorReplicationTopicNameConfigurationType")
class ReplicatorReplicationTopicNameConfigurationType(builtins.str, Enum):
    """
    The type of replicated topic name.
    """
    PREFIXED_WITH_SOURCE_CLUSTER_ALIAS = "PREFIXED_WITH_SOURCE_CLUSTER_ALIAS"
    IDENTICAL = "IDENTICAL"


@pulumi.type_token("aws-native:msk:VpcConnectionAuthentication")
class VpcConnectionAuthentication(builtins.str, Enum):
    """
    The type of private link authentication
    """
    SASL_IAM = "SASL_IAM"
    SASL_SCRAM = "SASL_SCRAM"
    TLS = "TLS"
