# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ClusterAccountingMode',
    'ClusterEndpointType',
    'ClusterSchedulerPropertiesType',
    'ClusterSize',
    'ClusterStatus',
    'ComputeNodeGroupPurchaseOption',
    'ComputeNodeGroupSpotOptionsPropertiesAllocationStrategy',
    'ComputeNodeGroupStatus',
    'QueueStatus',
]


@pulumi.type_token("aws-native:pcs:ClusterAccountingMode")
class ClusterAccountingMode(builtins.str, Enum):
    """
    The default value is `STANDARD`. A value of `STANDARD` means that Slurm accounting is enabled.
    """
    STANDARD = "STANDARD"
    NONE = "NONE"


@pulumi.type_token("aws-native:pcs:ClusterEndpointType")
class ClusterEndpointType(builtins.str, Enum):
    """
    Indicates the type of endpoint running at the specific IP address.
    """
    SLURMCTLD = "SLURMCTLD"
    SLURMDBD = "SLURMDBD"


@pulumi.type_token("aws-native:pcs:ClusterSchedulerPropertiesType")
class ClusterSchedulerPropertiesType(builtins.str, Enum):
    """
    The software AWS PCS uses to manage cluster scaling and job scheduling.
    """
    SLURM = "SLURM"


@pulumi.type_token("aws-native:pcs:ClusterSize")
class ClusterSize(builtins.str, Enum):
    """
    The size of the cluster.
    """
    SMALL = "SMALL"
    MEDIUM = "MEDIUM"
    LARGE = "LARGE"


@pulumi.type_token("aws-native:pcs:ClusterStatus")
class ClusterStatus(builtins.str, Enum):
    """
    The provisioning status of the cluster. The provisioning status doesn't indicate the overall health of the cluster.
    """
    CREATING = "CREATING"
    ACTIVE = "ACTIVE"
    UPDATING = "UPDATING"
    DELETING = "DELETING"
    CREATE_FAILED = "CREATE_FAILED"
    DELETE_FAILED = "DELETE_FAILED"
    UPDATE_FAILED = "UPDATE_FAILED"


@pulumi.type_token("aws-native:pcs:ComputeNodeGroupPurchaseOption")
class ComputeNodeGroupPurchaseOption(builtins.str, Enum):
    """
    Specifies how EC2 instances are purchased on your behalf. AWS PCS supports On-Demand and Spot instances. For more information, see Instance purchasing options in the Amazon Elastic Compute Cloud User Guide. If you don't provide this option, it defaults to On-Demand.
    """
    ONDEMAND = "ONDEMAND"
    SPOT = "SPOT"


@pulumi.type_token("aws-native:pcs:ComputeNodeGroupSpotOptionsPropertiesAllocationStrategy")
class ComputeNodeGroupSpotOptionsPropertiesAllocationStrategy(builtins.str, Enum):
    """
    The Amazon EC2 allocation strategy AWS PCS uses to provision EC2 instances. AWS PCS supports lowest price, capacity optimized, and price capacity optimized. If you don't provide this option, it defaults to price capacity optimized.
    """
    LOWEST_PRICE = "lowest-price"
    CAPACITY_OPTIMIZED = "capacity-optimized"
    PRICE_CAPACITY_OPTIMIZED = "price-capacity-optimized"


@pulumi.type_token("aws-native:pcs:ComputeNodeGroupStatus")
class ComputeNodeGroupStatus(builtins.str, Enum):
    """
    The provisioning status of the compute node group. The provisioning status doesn't indicate the overall health of the compute node group.
    """
    CREATING = "CREATING"
    ACTIVE = "ACTIVE"
    UPDATING = "UPDATING"
    DELETING = "DELETING"
    CREATE_FAILED = "CREATE_FAILED"
    DELETE_FAILED = "DELETE_FAILED"
    UPDATE_FAILED = "UPDATE_FAILED"


@pulumi.type_token("aws-native:pcs:QueueStatus")
class QueueStatus(builtins.str, Enum):
    """
    The provisioning status of the queue. The provisioning status doesn't indicate the overall health of the queue.
    """
    CREATING = "CREATING"
    ACTIVE = "ACTIVE"
    UPDATING = "UPDATING"
    DELETING = "DELETING"
    CREATE_FAILED = "CREATE_FAILED"
    DELETE_FAILED = "DELETE_FAILED"
    UPDATE_FAILED = "UPDATE_FAILED"
