# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AggregatorV2RegionLinkingMode',
    'AutomationRuleDateRangeUnit',
    'AutomationRuleMapFilterComparison',
    'AutomationRuleRuleStatus',
    'AutomationRuleSeverityUpdateLabel',
    'AutomationRuleStringFilterComparison',
    'AutomationRuleV2AllowedOperators',
    'AutomationRuleV2AutomationRulesActionV2Type',
    'AutomationRuleV2DateRangeUnit',
    'AutomationRuleV2MapFilterComparison',
    'AutomationRuleV2OcsfBooleanFilterFieldName',
    'AutomationRuleV2OcsfDateFilterFieldName',
    'AutomationRuleV2OcsfMapFilterFieldName',
    'AutomationRuleV2OcsfNumberFilterFieldName',
    'AutomationRuleV2OcsfStringField',
    'AutomationRuleV2RuleStatus',
    'AutomationRuleV2StringFilterComparison',
    'AutomationRuleWorkflowUpdateStatus',
    'AutomationRulesActionType',
    'AutomationRulesFindingFieldsUpdateVerificationState',
    'ConfigurationPolicyParameterConfigurationValueType',
    'DelegatedAdminStatus',
    'FindingAggregatorRegionLinkingMode',
    'InsightDateRangeUnit',
    'InsightMapFilterComparison',
    'InsightStringFilterComparison',
    'OrganizationConfigurationAutoEnableStandards',
    'OrganizationConfigurationConfigurationType',
    'OrganizationConfigurationStatus',
    'PolicyAssociationAssociationStatus',
    'PolicyAssociationAssociationType',
    'PolicyAssociationTargetType',
    'SecurityControlParameterConfigurationValueType',
]


@pulumi.type_token("aws-native:securityhub:AggregatorV2RegionLinkingMode")
class AggregatorV2RegionLinkingMode(builtins.str, Enum):
    """
    Indicates to link a list of included Regions
    """
    SPECIFIED_REGIONS = "SPECIFIED_REGIONS"


@pulumi.type_token("aws-native:securityhub:AutomationRuleDateRangeUnit")
class AutomationRuleDateRangeUnit(builtins.str, Enum):
    """
    A date range unit for the date filter.
    """
    DAYS = "DAYS"


@pulumi.type_token("aws-native:securityhub:AutomationRuleMapFilterComparison")
class AutomationRuleMapFilterComparison(builtins.str, Enum):
    """
    The condition to apply to the key value when filtering Security Hub findings with a map filter.
     To search for values that have the filter value, use one of the following comparison operators:
      +  To search for values that include the filter value, use ``CONTAINS``. For example, for the ``ResourceTags`` field, the filter ``Department CONTAINS Security`` matches findings that include the value ``Security`` for the ``Department`` tag. In the same example, a finding with a value of ``Security team`` for the ``Department`` tag is a match.
      +  To search for values that exactly match the filter value, use ``EQUALS``. For example, for the ``ResourceTags`` field, the filter ``Department EQUALS Security`` matches findings that have the value ``Security`` for the ``Department`` tag.
      
     ``CONTAINS`` and ``EQUALS`` filters on the same field are joined by ``OR``. A finding matches if it matches any one of those filters. For example, the filters ``Department CONTAINS Security OR Department CONTAINS Finance`` match a finding that includes either ``Security``, ``Finance``, or both values.
     To search for values that don't have the filter value, use one of the following comparison operators:
      +  To search for values that exclude the filter value, use ``NOT_CONTAINS``. For example, for the ``ResourceTags`` field, the filter ``Department NOT_CONTAINS Finance`` matches findings that exclude the value ``Finance`` for the ``Department`` tag.
      +  To search for values other than the filter value, use ``NOT_EQUALS``. For example, for the ``ResourceTags`` field, the filter ``Department NOT_EQUALS Finance`` matches findings that don’t have the value ``Finance`` for the ``Department`` tag.
      
     ``NOT_CONTAINS`` and ``NOT_EQUALS`` filters on the same field are joined by ``AND``. A finding matches only if it matches all of those filters. For example, the filters ``Department NOT_CONTAINS Security AND Department NOT_CONTAINS Finance`` match a finding that excludes both the ``Security`` and ``Finance`` values.
     ``CONTAINS`` filters can only be used with other ``CONTAINS`` filters. ``NOT_CONTAINS`` filters can only be used with other ``NOT_CONTAINS`` filters.
     You can’t have both a ``CONTAINS`` filter and a ``NOT_CONTAINS`` filter on the same field. Similarly, you can’t have both an ``EQUALS`` filter and a ``NOT_EQUALS`` filter on the same field. Combining filters in this way returns an error. 
     ``CONTAINS`` and ``NOT_CONTAINS`` operators can be used only with automation rules. For more information, see [Automation rules](https://docs.aws.amazon.com/securityhub/latest/userguide/automation-rules.html) in the *User Guide*.
    """
    EQUALS = "EQUALS"
    NOT_EQUALS = "NOT_EQUALS"
    CONTAINS = "CONTAINS"
    NOT_CONTAINS = "NOT_CONTAINS"


@pulumi.type_token("aws-native:securityhub:AutomationRuleRuleStatus")
class AutomationRuleRuleStatus(builtins.str, Enum):
    """
    Whether the rule is active after it is created. If this parameter is equal to ``ENABLED``, ASH applies the rule to findings and finding updates after the rule is created.
    """
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


@pulumi.type_token("aws-native:securityhub:AutomationRuleSeverityUpdateLabel")
class AutomationRuleSeverityUpdateLabel(builtins.str, Enum):
    """
    The severity value of the finding. The allowed values are the following.
      +  ``INFORMATIONAL`` - No issue was found.
      +  ``LOW`` - The issue does not require action on its own.
      +  ``MEDIUM`` - The issue must be addressed but not urgently.
      +  ``HIGH`` - The issue must be addressed as a priority.
      +  ``CRITICAL`` - The issue must be remediated immediately to avoid it escalating.
    """
    INFORMATIONAL = "INFORMATIONAL"
    LOW = "LOW"
    MEDIUM = "MEDIUM"
    HIGH = "HIGH"
    CRITICAL = "CRITICAL"


@pulumi.type_token("aws-native:securityhub:AutomationRuleStringFilterComparison")
class AutomationRuleStringFilterComparison(builtins.str, Enum):
    """
    The condition to apply to a string value when filtering Security Hub findings.
    """
    EQUALS = "EQUALS"
    PREFIX = "PREFIX"
    NOT_EQUALS = "NOT_EQUALS"
    PREFIX_NOT_EQUALS = "PREFIX_NOT_EQUALS"
    CONTAINS = "CONTAINS"
    NOT_CONTAINS = "NOT_CONTAINS"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2AllowedOperators")
class AutomationRuleV2AllowedOperators(builtins.str, Enum):
    """
    The logical operator used to combine multiple conditions
    """
    AND_ = "AND"
    OR_ = "OR"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2AutomationRulesActionV2Type")
class AutomationRuleV2AutomationRulesActionV2Type(builtins.str, Enum):
    """
    The category of action to be executed by the automation rule
    """
    FINDING_FIELDS_UPDATE = "FINDING_FIELDS_UPDATE"
    EXTERNAL_INTEGRATION = "EXTERNAL_INTEGRATION"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2DateRangeUnit")
class AutomationRuleV2DateRangeUnit(builtins.str, Enum):
    """
    A date range unit for the date filter
    """
    DAYS = "DAYS"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2MapFilterComparison")
class AutomationRuleV2MapFilterComparison(builtins.str, Enum):
    """
    The condition to apply to the key value when filtering findings with a map filter
    """
    EQUALS = "EQUALS"
    NOT_EQUALS = "NOT_EQUALS"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2OcsfBooleanFilterFieldName")
class AutomationRuleV2OcsfBooleanFilterFieldName(builtins.str, Enum):
    """
    The name of the field
    """
    COMPLIANCE_ASSESSMENTS_MEETS_CRITERIA = "compliance.assessments.meets_criteria"
    VULNERABILITIES_IS_EXPLOIT_AVAILABLE = "vulnerabilities.is_exploit_available"
    VULNERABILITIES_IS_FIX_AVAILABLE = "vulnerabilities.is_fix_available"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2OcsfDateFilterFieldName")
class AutomationRuleV2OcsfDateFilterFieldName(builtins.str, Enum):
    """
    The name of the field
    """
    FINDING_INFO_CREATED_TIME_DT = "finding_info.created_time_dt"
    FINDING_INFO_FIRST_SEEN_TIME_DT = "finding_info.first_seen_time_dt"
    FINDING_INFO_LAST_SEEN_TIME_DT = "finding_info.last_seen_time_dt"
    FINDING_INFO_MODIFIED_TIME_DT = "finding_info.modified_time_dt"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2OcsfMapFilterFieldName")
class AutomationRuleV2OcsfMapFilterFieldName(builtins.str, Enum):
    """
    The name of the field
    """
    RESOURCES_TAGS = "resources.tags"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2OcsfNumberFilterFieldName")
class AutomationRuleV2OcsfNumberFilterFieldName(builtins.str, Enum):
    """
    The name of the field
    """
    ACTIVITY_ID = "activity_id"
    COMPLIANCE_STATUS_ID = "compliance.status_id"
    CONFIDENCE_SCORE = "confidence_score"
    SEVERITY_ID = "severity_id"
    STATUS_ID = "status_id"
    FINDING_INFO_RELATED_EVENTS_COUNT = "finding_info.related_events_count"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2OcsfStringField")
class AutomationRuleV2OcsfStringField(builtins.str, Enum):
    """
    The name of the field
    """
    METADATA_UID = "metadata.uid"
    ACTIVITY_NAME = "activity_name"
    CLOUD_ACCOUNT_NAME = "cloud.account.name"
    CLOUD_ACCOUNT_UID = "cloud.account.uid"
    CLOUD_PROVIDER = "cloud.provider"
    CLOUD_REGION = "cloud.region"
    COMPLIANCE_ASSESSMENTS_CATEGORY = "compliance.assessments.category"
    COMPLIANCE_ASSESSMENTS_NAME = "compliance.assessments.name"
    COMPLIANCE_CONTROL = "compliance.control"
    COMPLIANCE_STATUS = "compliance.status"
    COMPLIANCE_STANDARDS = "compliance.standards"
    FINDING_INFO_DESC = "finding_info.desc"
    FINDING_INFO_SRC_URL = "finding_info.src_url"
    FINDING_INFO_TITLE = "finding_info.title"
    FINDING_INFO_TYPES = "finding_info.types"
    FINDING_INFO_UID = "finding_info.uid"
    FINDING_INFO_RELATED_EVENTS_UID = "finding_info.related_events.uid"
    FINDING_INFO_RELATED_EVENTS_PRODUCT_UID = "finding_info.related_events.product.uid"
    FINDING_INFO_RELATED_EVENTS_TITLE = "finding_info.related_events.title"
    METADATA_PRODUCT_FEATURE_UID = "metadata.product.feature.uid"
    METADATA_PRODUCT_NAME = "metadata.product.name"
    METADATA_PRODUCT_UID = "metadata.product.uid"
    METADATA_PRODUCT_VENDOR_NAME = "metadata.product.vendor_name"
    REMEDIATION_DESC = "remediation.desc"
    REMEDIATION_REFERENCES = "remediation.references"
    RESOURCES_CLOUD_PARTITION = "resources.cloud_partition"
    RESOURCES_NAME = "resources.name"
    RESOURCES_REGION = "resources.region"
    RESOURCES_TYPE = "resources.type"
    RESOURCES_UID = "resources.uid"
    SEVERITY = "severity"
    STATUS = "status"
    COMMENT = "comment"
    VULNERABILITIES_FIX_COVERAGE = "vulnerabilities.fix_coverage"
    CLASS_NAME = "class_name"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2RuleStatus")
class AutomationRuleV2RuleStatus(builtins.str, Enum):
    """
    The status of the automation rule
    """
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


@pulumi.type_token("aws-native:securityhub:AutomationRuleV2StringFilterComparison")
class AutomationRuleV2StringFilterComparison(builtins.str, Enum):
    """
    The condition to apply to a string value when filtering findings
    """
    EQUALS = "EQUALS"
    PREFIX = "PREFIX"
    NOT_EQUALS = "NOT_EQUALS"
    PREFIX_NOT_EQUALS = "PREFIX_NOT_EQUALS"
    CONTAINS = "CONTAINS"


@pulumi.type_token("aws-native:securityhub:AutomationRuleWorkflowUpdateStatus")
class AutomationRuleWorkflowUpdateStatus(builtins.str, Enum):
    """
    The status of the investigation into the finding. The workflow status is specific to an individual finding. It does not affect the generation of new findings. For example, setting the workflow status to ``SUPPRESSED`` or ``RESOLVED`` does not prevent a new finding for the same issue.
     The allowed values are the following.
      +  ``NEW`` - The initial state of a finding, before it is reviewed.
     Security Hub also resets ``WorkFlowStatus`` from ``NOTIFIED`` or ``RESOLVED`` to ``NEW`` in the following cases:
      +  The record state changes from ``ARCHIVED`` to ``ACTIVE``.
      +  The compliance status changes from ``PASSED`` to either ``WARNING``, ``FAILED``, or ``NOT_AVAILABLE``.
      
      +  ``NOTIFIED`` - Indicates that you notified the resource owner about the security issue. Used when the initial reviewer is not the resource owner, and needs intervention from the resource owner.
      +  ``RESOLVED`` - The finding was reviewed and remediated and is now considered resolved.
      +  ``SUPPRESSED`` - Indicates that you reviewed the finding and don't believe that any action is needed. The finding is no longer updated.
    """
    NEW = "NEW"
    NOTIFIED = "NOTIFIED"
    RESOLVED = "RESOLVED"
    SUPPRESSED = "SUPPRESSED"


@pulumi.type_token("aws-native:securityhub:AutomationRulesActionType")
class AutomationRulesActionType(builtins.str, Enum):
    """
    Specifies the type of action that Security Hub takes when a finding matches the defined criteria of a rule.
    """
    FINDING_FIELDS_UPDATE = "FINDING_FIELDS_UPDATE"


@pulumi.type_token("aws-native:securityhub:AutomationRulesFindingFieldsUpdateVerificationState")
class AutomationRulesFindingFieldsUpdateVerificationState(builtins.str, Enum):
    """
    The rule action updates the ``VerificationState`` field of a finding.
    """
    UNKNOWN = "UNKNOWN"
    TRUE_POSITIVE = "TRUE_POSITIVE"
    FALSE_POSITIVE = "FALSE_POSITIVE"
    BENIGN_POSITIVE = "BENIGN_POSITIVE"


@pulumi.type_token("aws-native:securityhub:ConfigurationPolicyParameterConfigurationValueType")
class ConfigurationPolicyParameterConfigurationValueType(builtins.str, Enum):
    """
    Identifies whether a control parameter uses a custom user-defined value or subscribes to the default AWS Security Hub behavior.
    """
    DEFAULT = "DEFAULT"
    CUSTOM = "CUSTOM"


@pulumi.type_token("aws-native:securityhub:DelegatedAdminStatus")
class DelegatedAdminStatus(builtins.str, Enum):
    """
    Whether the delegated Security Hub administrator is set for the organization.
    """
    ENABLED = "ENABLED"
    DISABLE_IN_PROGRESS = "DISABLE_IN_PROGRESS"


@pulumi.type_token("aws-native:securityhub:FindingAggregatorRegionLinkingMode")
class FindingAggregatorRegionLinkingMode(builtins.str, Enum):
    """
    Indicates whether to aggregate findings from all of the available Regions in the current partition. Also determines whether to automatically aggregate findings from new Regions as Security Hub supports them and you opt into them.
     The selected option also determines how to use the Regions provided in the Regions list.
     In CFN, the options for this property are as follows:
      +  ``ALL_REGIONS`` - Indicates to aggregate findings from all of the Regions where Security Hub is enabled. When you choose this option, Security Hub also automatically aggregates findings from new Regions as Security Hub supports them and you opt into them. 
      +  ``ALL_REGIONS_EXCEPT_SPECIFIED`` - Indicates to aggregate findings from all of the Regions where Security Hub is enabled, except for the Regions listed in the ``Regions`` parameter. When you choose this option, Security Hub also automatically aggregates findings from new Regions as Security Hub supports them and you opt into them. 
      +  ``SPECIFIED_REGIONS`` - Indicates to aggregate findings only from the Regions listed in the ``Regions`` parameter. Security Hub does not automatically aggregate findings from new Regions.
    """
    ALL_REGIONS = "ALL_REGIONS"
    ALL_REGIONS_EXCEPT_SPECIFIED = "ALL_REGIONS_EXCEPT_SPECIFIED"
    SPECIFIED_REGIONS = "SPECIFIED_REGIONS"


@pulumi.type_token("aws-native:securityhub:InsightDateRangeUnit")
class InsightDateRangeUnit(builtins.str, Enum):
    """
    A date range unit for the date filter.
    """
    DAYS = "DAYS"


@pulumi.type_token("aws-native:securityhub:InsightMapFilterComparison")
class InsightMapFilterComparison(builtins.str, Enum):
    """
    The condition to apply to the key value when filtering Security Hub findings with a map filter.
    """
    EQUALS = "EQUALS"
    NOT_EQUALS = "NOT_EQUALS"


@pulumi.type_token("aws-native:securityhub:InsightStringFilterComparison")
class InsightStringFilterComparison(builtins.str, Enum):
    """
    The condition to apply to a string value when filtering Security Hub findings.
    """
    EQUALS = "EQUALS"
    PREFIX = "PREFIX"
    NOT_EQUALS = "NOT_EQUALS"
    PREFIX_NOT_EQUALS = "PREFIX_NOT_EQUALS"


@pulumi.type_token("aws-native:securityhub:OrganizationConfigurationAutoEnableStandards")
class OrganizationConfigurationAutoEnableStandards(builtins.str, Enum):
    """
    Whether to automatically enable Security Hub default standards in new member accounts when they join the organization.
    """
    DEFAULT = "DEFAULT"
    NONE = "NONE"


@pulumi.type_token("aws-native:securityhub:OrganizationConfigurationConfigurationType")
class OrganizationConfigurationConfigurationType(builtins.str, Enum):
    """
    Indicates whether the organization uses local or central configuration.
    """
    CENTRAL = "CENTRAL"
    LOCAL = "LOCAL"


@pulumi.type_token("aws-native:securityhub:OrganizationConfigurationStatus")
class OrganizationConfigurationStatus(builtins.str, Enum):
    """
    Describes whether central configuration could be enabled as the ConfigurationType for the organization.
    """
    PENDING = "PENDING"
    ENABLED = "ENABLED"
    FAILED = "FAILED"


@pulumi.type_token("aws-native:securityhub:PolicyAssociationAssociationStatus")
class PolicyAssociationAssociationStatus(builtins.str, Enum):
    """
    The current status of the association between the specified target and the configuration
    """
    SUCCESS = "SUCCESS"
    PENDING = "PENDING"
    FAILED = "FAILED"


@pulumi.type_token("aws-native:securityhub:PolicyAssociationAssociationType")
class PolicyAssociationAssociationType(builtins.str, Enum):
    """
    Indicates whether the association between the specified target and the configuration was directly applied by the Security Hub delegated administrator or inherited from a parent
    """
    APPLIED = "APPLIED"
    INHERITED = "INHERITED"


@pulumi.type_token("aws-native:securityhub:PolicyAssociationTargetType")
class PolicyAssociationTargetType(builtins.str, Enum):
    """
    Indicates whether the target is an AWS account, organizational unit, or the organization root
    """
    ACCOUNT = "ACCOUNT"
    ORGANIZATIONAL_UNIT = "ORGANIZATIONAL_UNIT"
    ROOT = "ROOT"


@pulumi.type_token("aws-native:securityhub:SecurityControlParameterConfigurationValueType")
class SecurityControlParameterConfigurationValueType(builtins.str, Enum):
    """
    Identifies whether a control parameter uses a custom user-defined value or subscribes to the default AWS Security Hub behavior.

    When `ValueType` is set equal to `DEFAULT` , the default behavior can be a specific Security Hub default value, or the default behavior can be to ignore a specific parameter. When `ValueType` is set equal to `DEFAULT` , Security Hub ignores user-provided input for the `Value` field.

    When `ValueType` is set equal to `CUSTOM` , the `Value` field can't be empty.
    """
    DEFAULT = "DEFAULT"
    CUSTOM = "CUSTOM"
