# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from .. import _inputs as _root_inputs
from .. import outputs as _root_outputs

__all__ = ['MailManagerAddressListArgs', 'MailManagerAddressList']

@pulumi.input_type
class MailManagerAddressListArgs:
    def __init__(__self__, *,
                 address_list_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]] = None):
        """
        The set of arguments for constructing a MailManagerAddressList resource.
        """
        if address_list_name is not None:
            pulumi.set(__self__, "address_list_name", address_list_name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="addressListName")
    def address_list_name(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "address_list_name")

    @address_list_name.setter
    def address_list_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "address_list_name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]]):
        pulumi.set(self, "tags", value)


@pulumi.type_token("aws-native:ses:MailManagerAddressList")
class MailManagerAddressList(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_list_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[Union['_root_inputs.TagArgs', '_root_inputs.TagArgsDict']]]]] = None,
                 __props__=None):
        """
        Definition of AWS::SES::MailManagerAddressList Resource Type

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[MailManagerAddressListArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Definition of AWS::SES::MailManagerAddressList Resource Type

        :param str resource_name: The name of the resource.
        :param MailManagerAddressListArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MailManagerAddressListArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_list_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[Union['_root_inputs.TagArgs', '_root_inputs.TagArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MailManagerAddressListArgs.__new__(MailManagerAddressListArgs)

            __props__.__dict__["address_list_name"] = address_list_name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["address_list_arn"] = None
            __props__.__dict__["address_list_id"] = None
        replace_on_changes = pulumi.ResourceOptions(replace_on_changes=["addressListName"])
        opts = pulumi.ResourceOptions.merge(opts, replace_on_changes)
        super(MailManagerAddressList, __self__).__init__(
            'aws-native:ses:MailManagerAddressList',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'MailManagerAddressList':
        """
        Get an existing MailManagerAddressList resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = MailManagerAddressListArgs.__new__(MailManagerAddressListArgs)

        __props__.__dict__["address_list_arn"] = None
        __props__.__dict__["address_list_id"] = None
        __props__.__dict__["address_list_name"] = None
        __props__.__dict__["tags"] = None
        return MailManagerAddressList(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="addressListArn")
    def address_list_arn(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "address_list_arn")

    @property
    @pulumi.getter(name="addressListId")
    def address_list_id(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "address_list_id")

    @property
    @pulumi.getter(name="addressListName")
    def address_list_name(self) -> pulumi.Output[Optional[builtins.str]]:
        return pulumi.get(self, "address_list_name")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence['_root_outputs.Tag']]]:
        return pulumi.get(self, "tags")

